import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.Math;

/**
 * Write a description of class Turret here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Turret extends SmoothMover
{
    private HP turretAngleCounter;
    private boolean primaryFire, secondaryFire;
    private int cooldown = 0;
    public int fireRate = 10;
    private int health = 10;
    private int enemySpawnMaxCooldown = 100;
    private int enemySpawnCooldown = enemySpawnMaxCooldown;
    
    public void takeDamage(int x)
    {
        health -= x;
        
        if (health <= 0)
        {
            Greenfoot.stop();
        }
    }
    
    public Turret(HP turretAngleCounter)
    {
        this.turretAngleCounter = turretAngleCounter;
    }
    
    public int getRandomNumber(int start,int end)
    {
        int normal = Greenfoot.getRandomNumber(end-start+1);
        return normal+start;
    }
    
    public void spawnGrenadeer()
    {
        if (0 == enemySpawnCooldown)
        {
            int x = 0, y = 0;
            int side = getRandomNumber(0, 3);
            switch (side)
            {
                case 0: y = 0; x = getRandomNumber(0, 600); break;
                case 1: y = getRandomNumber(0, 400); x = 600; break;
                case 2: y = 400; x = getRandomNumber(0, 600); break;
                case 3: y = getRandomNumber(0, 600); x = 0; break;
            }
            ((MyWorld)getWorld()).addObject(new Grenadeer(this), x, y);
            enemySpawnCooldown = enemySpawnMaxCooldown;
        }
        else
        {
            enemySpawnCooldown--;
        }
    }
    
    /**
     * Act - do whatever the Turret wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        spawnGrenadeer();
        
        turretAngleCounter.setValue(health);
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if (Greenfoot.mouseMoved(null) || Greenfoot.mouseDragged(null)) {
                turnTowards(mouse.getX(), mouse.getY());
            }
            
            if (cooldown > 0)
            cooldown--;
            if (Greenfoot.mouseMoved(null)) {
                turnTowards(mouse.getX(), mouse.getY());
            }
            if (primaryFire && (Greenfoot.mouseDragEnded(null) || Greenfoot.mouseClicked(null))) primaryFire = false;
            if (!primaryFire && Greenfoot.mousePressed(null)) {
                switch (mouse.getButton()) {
                    case 1: primaryFire = true; break;
                }
            }
            if (primaryFire) {
                turnTowards(mouse.getX(), mouse.getY());
                if (cooldown == 0) {
                    getWorld().setPaintOrder(Turret.class, Bullet.class);
                    Greenfoot.playSound("turret_01.mp3");
                    getWorld().addObject(new Bullet(getRotation()+getRandomNumber(-1,1)), getX(), getY());
                    cooldown = fireRate;
                }
            }
        }
        /*
        setLocation(
            getExactX()+Math.cos(getRotation()),
            getExactY()+Math.sin(getRotation())
        );
        */
    }
}
